diff --git a/gcc/analyzer/region-model.cc b/gcc/analyzer/region-model.cc
index 0794be9a583..e7785eb54d1 100644
--- a/gcc/analyzer/region-model.cc
+++ b/gcc/analyzer/region-model.cc
@@ -3501,68 +139,39 @@ region_model::~region_model ()
 region_model &
 region_model::operator= (const region_model &other)
 {
-  unsigned i;
-  svalue *svalue;
-  region *region;
+  /* m_mgr is const.  */
+  gcc_assert (m_mgr == other.m_mgr);
 
-  /* Delete existing content.  */
-  FOR_EACH_VEC_ELT (m_svalues, i, svalue)
-    delete svalue;
-  m_svalues.truncate (0);
-
-  FOR_EACH_VEC_ELT (m_regions, i, region)
-    delete region;
-  m_regions.truncate (0);
+  m_store = other.m_store;
 
   delete m_constraints;
+  m_constraints = new constraint_manager (*other.m_constraints);
 
-  /* Clone the svalues and regions.  */
-  m_svalues.reserve (other.m_svalues.length (), true);
-  FOR_EACH_VEC_ELT (other.m_svalues, i, svalue)
-    m_svalues.quick_push (svalue->clone ());
-
-  m_regions.reserve (other.m_regions.length (), true);
-  FOR_EACH_VEC_ELT (other.m_regions, i, region)
-    m_regions.quick_push (region->clone ());
-
-  m_root_rid = other.m_root_rid;
-
-  m_constraints = other.m_constraints->clone (this);
+  m_current_frame = other.m_current_frame;
 
   return *this;
 }
 
 /* Equality operator for region_model.
 
-   Amongst other things this directly compares the svalue and region
-   vectors and so for this to be meaningful both this and OTHER should
+   Amongst other things this directly compares the stores and the constraint
+   managers, so for this to be meaningful both this and OTHER should
    have been canonicalized.  */
 
 bool
 region_model::operator== (const region_model &other) const
 {
-  if (m_root_rid != other.m_root_rid)
-    return false;
-
-  if (m_svalues.length () != other.m_svalues.length ())
-    return false;
+  /* We can only compare instances that use the same manager.  */
+  gcc_assert (m_mgr == other.m_mgr);
 
-  if (m_regions.length () != other.m_regions.length ())
+  if (m_store != other.m_store)
     return false;
 
   if (*m_constraints != *other.m_constraints)
     return false;
 
-  unsigned i;
-  svalue *svalue;
-  FOR_EACH_VEC_ELT (other.m_svalues, i, svalue)
-    if (!(*m_svalues[i] == *other.m_svalues[i]))
-      return false;
-
-  region *region;
-  FOR_EACH_VEC_ELT (other.m_regions, i, region)
-    if (!(*m_regions[i] == *other.m_regions[i]))
-      return false;
+  if (m_current_frame != other.m_current_frame)
+    return false;
 
   gcc_checking_assert (hash () == other.hash ());
 
@@ -3574,456 +183,103 @@ region_model::operator== (const region_model &other) const
 hashval_t
 region_model::hash () const
 {
-  hashval_t result = 0;
-  int i;
-
-  svalue *svalue;
-  FOR_EACH_VEC_ELT (m_svalues, i, svalue)
-    result ^= svalue->hash ();
-
-  region *region;
-  FOR_EACH_VEC_ELT (m_regions, i, region)
-    result ^= region->hash ();
-
+  hashval_t result = m_store.hash ();
   result ^= m_constraints->hash ();
-
   return result;
 }
 
-/* Print an all-on-one-line representation of this region_model to PP,
-   which must support %E for trees.  */
-
-void
-region_model::print (pretty_printer *pp) const
-{
-  int i;
-
-  pp_string (pp, "svalues: [");
-  svalue *svalue;
-  FOR_EACH_VEC_ELT (m_svalues, i, svalue)
-    {
-      if (i > 0)
-	pp_string (pp, ", ");
-      print_svalue (svalue_id::from_int (i), pp);
-    }
-
-  pp_string (pp, "], regions: [");
-
-  region *region;
-  FOR_EACH_VEC_ELT (m_regions, i, region)
-    {
-      if (i > 0)
-	pp_string (pp, ", ");
-      region->print (*this, region_id::from_int (i), pp);
-    }
-
-  pp_string (pp, "], constraints: ");
-
-  m_constraints->print (pp);
-}
-
-/* Print the svalue with id SID to PP.  */
-
-void
-region_model::print_svalue (svalue_id sid, pretty_printer *pp) const
-{
-  get_svalue (sid)->print (*this, sid, pp);
-}
-
-/* Dump a .dot representation of this region_model to PP, showing
-   the values and the hierarchy of regions.  */
-
-void
-region_model::dump_dot_to_pp (pretty_printer *pp) const
-{
-  graphviz_out gv (pp);
-
-  pp_string (pp, "digraph \"");
-  pp_write_text_to_stream (pp);
-  pp_write_text_as_dot_label_to_stream (pp, /*for_record=*/false);
-  pp_string (pp, "\" {\n");
-
-  gv.indent ();
-
-  pp_string (pp, "overlap=false;\n");
-  pp_string (pp, "compound=true;\n");
-
-  int i;
-
-  svalue *svalue;
-  FOR_EACH_VEC_ELT (m_svalues, i, svalue)
-    svalue->dump_dot_to_pp (*this, svalue_id::from_int (i), pp);
-
-  region *region;
-  FOR_EACH_VEC_ELT (m_regions, i, region)
-    region->dump_dot_to_pp (*this, region_id::from_int (i), pp);
-
-  /* TODO: constraints.  */
-
-  /* Terminate "digraph" */
-  gv.outdent ();
-  pp_string (pp, "}");
-  pp_newline (pp);
-}
-
-/* Dump a .dot representation of this region_model to FP.  */
-
-void
-region_model::dump_dot_to_file (FILE *fp) const
-{
-  pretty_printer pp;
-  pp_format_decoder (&pp) = default_tree_printer;
-  pp.buffer->stream = fp;
-  dump_dot_to_pp (&pp);
-  pp_flush (&pp);
-}
-
-/* Dump a .dot representation of this region_model to PATH.  */
-
-void
-region_model::dump_dot (const char *path) const
-{
-  FILE *fp = fopen (path, "w");
-  dump_dot_to_file (fp);
-  fclose (fp);
-}
-
-/* Dump a multiline representation of this model to PP, showing the
-   region hierarchy, the svalues, and any constraints.
+// FIXME:
+/* Dump a representation of this model to PP, showing the
+   stack, the store, and any constraints.
 
-   If SUMMARIZE is true, show only the most pertinent information,
+   If SIMPLE is true, show only the most pertinent information,
    in a form that attempts to be less verbose.
-   Otherwise, show all information.  */
+   Otherwise, show all information.
+
+   If MULTILINE... FIXME.  */
 
 void
-region_model::dump_to_pp (pretty_printer *pp, bool summarize) const
+region_model::dump_to_pp (pretty_printer *pp, bool simple,
+			  bool multiline) const
 {
-  if (summarize)
-    {
-      auto_vec<path_var> rep_path_vars;
-
-      unsigned i;
-      region *reg;
-      FOR_EACH_VEC_ELT (m_regions, i, reg)
-	{
-	  region_id rid = region_id::from_int (i);
-	  path_var pv = get_representative_path_var (rid);
-	  if (pv.m_tree)
-	    rep_path_vars.safe_push (pv);
-	}
-      bool is_first = true;
-
-      /* Work with a copy in case the get_lvalue calls change anything
-	 (they shouldn't).  */
-      region_model copy (*this);
-      copy.dump_summary_of_rep_path_vars (pp, &rep_path_vars, &is_first);
-
-      equiv_class *ec;
-      FOR_EACH_VEC_ELT (m_constraints->m_equiv_classes, i, ec)
-	{
-	  for (unsigned j = 0; j < ec->m_vars.length (); j++)
-	    {
-	      svalue_id lhs_sid = ec->m_vars[j];
-	      tree lhs_tree = get_representative_tree (lhs_sid);
-	      if (lhs_tree == NULL_TREE)
-		continue;
-	      for (unsigned k = j + 1; k < ec->m_vars.length (); k++)
-		{
-		  svalue_id rhs_sid = ec->m_vars[k];
-		  tree rhs_tree = get_representative_tree (rhs_sid);
-		  if (rhs_tree
-		      && !(CONSTANT_CLASS_P (lhs_tree)
-			   && CONSTANT_CLASS_P (rhs_tree)))
-		    {
-		      dump_separator (pp, &is_first);
-		      dump_tree (pp, lhs_tree);
-		      pp_string (pp, " == ");
-		      dump_tree (pp, rhs_tree);
-		    }
-		}
-	    }
-	}
-
-      constraint *c;
-      FOR_EACH_VEC_ELT (m_constraints->m_constraints, i, c)
-	{
-	  const equiv_class &lhs = c->m_lhs.get_obj (*m_constraints);
-	  const equiv_class &rhs = c->m_rhs.get_obj (*m_constraints);
-	  svalue_id lhs_sid = lhs.get_representative ();
-	  svalue_id rhs_sid = rhs.get_representative ();
-	  tree lhs_tree = get_representative_tree (lhs_sid);
-	  tree rhs_tree = get_representative_tree (rhs_sid);
-	  if (lhs_tree && rhs_tree
-	      && !(CONSTANT_CLASS_P (lhs_tree) && CONSTANT_CLASS_P (rhs_tree)))
-	    {
-	      dump_separator (pp, &is_first);
-	      dump_tree (pp, lhs_tree);
-	      pp_printf (pp, " %s ", constraint_op_code (c->m_op));
-	      dump_tree (pp, rhs_tree);
-	   }
-	}
-
-      return;
-    }
-
-  get_region (m_root_rid)->dump_to_pp (*this, m_root_rid, pp, "", true);
-
-  pp_string (pp, "svalues:");
-  pp_newline (pp);
-  int i;
-  svalue *svalue;
-  FOR_EACH_VEC_ELT (m_svalues, i, svalue)
+  /* Dump stack.  */
+  pp_printf (pp, "stack depth: %i", get_stack_depth ());
+  if (multiline)
+    pp_newline (pp);
+  else
+    pp_string (pp, " {");
+  for (const frame_region *iter_frame = m_current_frame; iter_frame;
+       iter_frame = iter_frame->get_calling_frame ())
     {
-      pp_string (pp, "  ");
-      svalue_id sid = svalue_id::from_int (i);
-      print_svalue (sid, pp);
-      pp_newline (pp);
-    }
-
-  pp_string (pp, "constraint manager:");
-  pp_newline (pp);
-  m_constraints->dump_to_pp (pp);
+      if (multiline)
+	pp_string (pp, "  ");
+      else if (iter_frame != m_current_frame)
+	pp_string (pp, ", ");
+      pp_printf (pp, "frame (index %i): ", iter_frame->get_index ());
+      iter_frame->dump_to_pp (pp, simple);
+      if (multiline)
+	pp_newline (pp);
+    }
+  if (!multiline)
+    pp_string (pp, "}");
+
+  /* Dump store.  */
+  if (!multiline)
+    pp_string (pp, ", {");
+  m_store.dump_to_pp (pp, simple, multiline,
+		      m_mgr->get_store_manager ());
+  if (!multiline)
+    pp_string (pp, "}");
+
+  /* Dump constraints.  */
+  pp_string (pp, "constraint_manager:");
+  if (multiline)
+    pp_newline (pp);
+  else
+    pp_string (pp, " {");
+  m_constraints->dump_to_pp (pp, multiline);
+  if (!multiline)
+    pp_string (pp, "}");
 }
 
-/* Dump a multiline representation of this model to FILE.  */
+/* Dump a representation of this model to FILE.  */
 
 void
-region_model::dump (FILE *fp, bool summarize) const
+region_model::dump (FILE *fp, bool simple, bool multiline) const
 {
   pretty_printer pp;
   pp_format_decoder (&pp) = default_tree_printer;
   pp_show_color (&pp) = pp_show_color (global_dc->printer);
   pp.buffer->stream = fp;
-  dump_to_pp (&pp, summarize);
+  dump_to_pp (&pp, simple, multiline);
+  pp_newline (&pp);
   pp_flush (&pp);
 }
 
 /* Dump a multiline representation of this model to stderr.  */
 
 DEBUG_FUNCTION void
-region_model::dump (bool summarize) const
+region_model::dump (bool simple) const
 {
-  dump (stderr, summarize);
+  dump (stderr, simple, true);
 }
 
-/* Dump RMODEL fully to stderr (i.e. without summarization).  */
+/* Dump a multiline representation of this model to stderr.  */
 
 DEBUG_FUNCTION void
 region_model::debug () const
 {
-  dump (false);
-}
-
-/* Dump VEC to PP, in the form "{VEC elements}: LABEL".  */
-
-static void
-dump_vec_of_tree (pretty_printer *pp,
-		  bool *is_first,
-		  const auto_vec<tree> &vec,
-		  const char *label)
-{
-  if (vec.length () == 0)
-    return;
-
-  dump_separator (pp, is_first);
-  pp_printf (pp, "{");
-  unsigned i;
-  tree key;
-  FOR_EACH_VEC_ELT (vec, i, key)
-    {
-      if (i > 0)
-	pp_string (pp, ", ");
-      dump_tree (pp, key);
-    }
-  pp_printf (pp, "}: %s", label);
-}
-
-/* Dump all *REP_PATH_VARS to PP in compact form, updating *IS_FIRST.
-   Subroutine of region_model::dump_to_pp.  */
-
-void
-region_model::dump_summary_of_rep_path_vars (pretty_printer *pp,
-					     auto_vec<path_var> *rep_path_vars,
-					     bool *is_first)
-{
-  /* Print pointers, constants, and poisoned values that aren't "uninit";
-     gather keys for unknown and uninit values.  */
-  unsigned i;
-  path_var *pv;
-  auto_vec<tree> unknown_trees;
-  FOR_EACH_VEC_ELT (*rep_path_vars, i, pv)
-    {
-      if (TREE_CODE (pv->m_tree) == STRING_CST)
-	continue;
-      tentative_region_model_context ctxt;
-      region_id child_rid = get_lvalue (*pv, &ctxt);
-      if (ctxt.had_errors_p ())
-	continue;
-      region *child_region = get_region (child_rid);
-      if (!child_region)
-	continue;
-      svalue_id sid = child_region->get_value_direct ();
-      if (sid.null_p ())
-	continue;
-      svalue *sval = get_svalue (sid);
-      switch (sval->get_kind ())
-	{
-	default:
-	  gcc_unreachable ();
-	case SK_REGION:
-	  {
-	    region_svalue *region_sval = as_a <region_svalue *> (sval);
-	    region_id pointee_rid = region_sval->get_pointee ();
-	    gcc_assert (!pointee_rid.null_p ());
-	    tree pointee = get_representative_path_var (pointee_rid).m_tree;
-	    dump_separator (pp, is_first);
-	    dump_tree (pp, pv->m_tree);
-	    pp_string (pp, ": ");
-	    pp_character (pp, '&');
-	    if (pointee)
-	      dump_tree (pp, pointee);
-	    else
-	      pointee_rid.print (pp);
-	  }
-	  break;
-	case SK_CONSTANT:
-	  dump_separator (pp, is_first);
-	  dump_tree (pp, pv->m_tree);
-	  pp_string (pp, ": ");
-	  dump_tree (pp, sval->dyn_cast_constant_svalue ()->get_constant ());
-	  break;
-	case SK_UNKNOWN:
-	  unknown_trees.safe_push (pv->m_tree);
-	  break;
-	case SK_POISONED:
-	  {
-	    poisoned_svalue *poisoned_sval = as_a <poisoned_svalue *> (sval);
-	    enum poison_kind pkind = poisoned_sval->get_poison_kind ();
-	    dump_separator (pp, is_first);
-	    dump_tree (pp, pv->m_tree);
-	    pp_printf (pp, ": %s", poison_kind_to_str (pkind));
-	  }
-	  break;
-	case SK_SETJMP:
-	  dump_separator (pp, is_first);
-	  pp_printf (pp, "setjmp: EN: %i",
-		     sval->dyn_cast_setjmp_svalue ()->get_enode_index ());
-	  break;
-	}
-    }
-
-  /* Print unknown and uninitialized values in consolidated form.  */
-  dump_vec_of_tree (pp, is_first, unknown_trees, "unknown");
-}
-
-/* Assert that this object is valid.  */
-
-void
-region_model::validate () const
-{
-  /* Skip this in a release build.  */
-#if !CHECKING_P
-  return;
-#endif
-
-  m_constraints->validate ();
-
-  unsigned i;
-  region *r;
-  FOR_EACH_VEC_ELT (m_regions, i, r)
-    r->validate (*this);
-
-  // TODO: anything else?
-}
-
-/* Global data for use by svalue_id_cmp_by_constant_svalue.  */
-
-static region_model *svalue_id_cmp_by_constant_svalue_model = NULL;
-
-/* Comparator for use by region_model::canonicalize.  */
-
-static int
-svalue_id_cmp_by_constant_svalue (const void *p1, const void *p2)
-{
-  const svalue_id *sid1 = (const svalue_id *)p1;
-  const svalue_id *sid2 = (const svalue_id *)p2;
-  gcc_assert (!sid1->null_p ());
-  gcc_assert (!sid2->null_p ());
-  gcc_assert (svalue_id_cmp_by_constant_svalue_model);
-  const svalue &sval1
-    = *svalue_id_cmp_by_constant_svalue_model->get_svalue (*sid1);
-  const svalue &sval2
-    = *svalue_id_cmp_by_constant_svalue_model->get_svalue (*sid2);
-  gcc_assert (sval1.get_kind () == SK_CONSTANT);
-  gcc_assert (sval2.get_kind () == SK_CONSTANT);
-
-  tree cst1 = ((const constant_svalue &)sval1).get_constant ();
-  tree cst2 = ((const constant_svalue &)sval2).get_constant ();
-  return tree_cmp (cst1, cst2);
+  dump (true);
 }
 
-/* Reorder the regions and svalues into a deterministic "canonical" order,
-   to maximize the chance of equality.
-   If non-NULL, notify CTXT about the svalue id remapping.  */
+/* Canonicalize the store and constraints, to maximize the chance of
+   equality between region_model instances.  */
 
 void
-region_model::canonicalize (region_model_context *ctxt)
-{
-  /* Walk all regions and values in a deterministic order, visiting
-     rids and sids, generating a rid and sid map.  */
-  canonicalization c (*this);
-
-  /* (1): Walk all svalues, putting constants first, sorting the constants
-     (thus imposing an ordering on any constants that are purely referenced
-     by constraints).
-     Ignore other svalues for now.  */
-  {
-    unsigned i;
-    auto_vec<svalue_id> sids;
-    svalue *sval;
-    FOR_EACH_VEC_ELT (m_svalues, i, sval)
-      {
-	if (sval->get_kind () == SK_CONSTANT)
-	  sids.safe_push (svalue_id::from_int (i));
-      }
-    svalue_id_cmp_by_constant_svalue_model = this;
-    sids.qsort (svalue_id_cmp_by_constant_svalue);
-    svalue_id_cmp_by_constant_svalue_model = NULL;
-    svalue_id *sid;
-    FOR_EACH_VEC_ELT (sids, i, sid)
-      c.walk_sid (*sid);
-  }
-
-  /* (2): Walk all regions (and thus their values) in a deterministic
-     order.  */
-  c.walk_rid (m_root_rid);
-
-  /* (3): Ensure we've visited everything, as we don't want to purge
-     at this stage.  Anything we visit for the first time here has
-     arbitrary order.  */
-  {
-    unsigned i;
-    region *region;
-    FOR_EACH_VEC_ELT (m_regions, i, region)
-      c.walk_rid (region_id::from_int (i));
-    svalue *sval;
-    FOR_EACH_VEC_ELT (m_svalues, i, sval)
-      c.walk_sid (svalue_id::from_int (i));
-  }
-
-  /* (4): We now have a reordering of the regions and values.
-     Apply it.  */
-  remap_svalue_ids (c.m_sid_map);
-  remap_region_ids (c.m_rid_map);
-  if (ctxt)
-    ctxt->remap_svalue_ids (c.m_sid_map);
-
-  /* (5): Canonicalize the constraint_manager (it has already had its
-     svalue_ids remapped above).  This makes use of the new svalue_id
-     values, and so must happen last.  */
-  m_constraints->canonicalize (get_num_svalues ());
-
-  validate ();
+region_model::canonicalize ()
+{
+  m_store.canonicalize (m_mgr->get_store_manager ());
+  m_constraints->canonicalize ();
 }
 
 /* Return true if this region_model is in canonical form.  */
@@ -4032,10 +288,18 @@ bool
 region_model::canonicalized_p () const
 {
   region_model copy (*this);
-  copy.canonicalize (NULL);
+  copy.canonicalize ();
   return *this == copy;
 }
 
+/* See the comment for store::loop_replay_fixup.  */
+
+void
+region_model::loop_replay_fixup (const region_model *dst_state)
+{
+  m_store.loop_replay_fixup (dst_state->get_store (), m_mgr);
+}
+
 /* A subclass of pending_diagnostic for complaining about uses of
    poisoned values.  */
 
@@ -4073,10 +337,11 @@ public:
       case POISON_KIND_POPPED_STACK:
 	{
 	  /* TODO: which CWE?  */
-	  return warning_at (rich_loc,
-			     OPT_Wanalyzer_use_of_pointer_in_stale_stack_frame,
-			     "use of pointer %qE within stale stack frame",
-			     m_expr);
+	  return warning_at
+	    (rich_loc,
+	     OPT_Wanalyzer_use_of_pointer_in_stale_stack_frame,
+	     "dereferencing pointer %qE to within stale stack frame",
+	     m_expr);
 	}
 	break;
       }
@@ -4093,7 +358,7 @@ public:
 				   m_expr);
       case POISON_KIND_POPPED_STACK:
 	return ev.formatted_print
-	  ("use of pointer %qE within stale stack frame here",
+	  ("dereferencing pointer %qE to within stale stack frame",
 	   m_expr);
       }
   }
@@ -4103,85 +368,22 @@ private:
   enum poison_kind m_pkind;
 };
 
-/* Determine if EXPR is poisoned, and if so, queue a diagnostic to CTXT.  */
-
-void
-region_model::check_for_poison (tree expr, region_model_context *ctxt)
-{
-  if (!ctxt)
-    return;
-
-  // TODO: this is disabled for now (too many false positives)
-  return;
-
-  svalue_id expr_sid = get_rvalue (expr, ctxt);
-  gcc_assert (!expr_sid.null_p ());
-  svalue *expr_svalue = get_svalue (expr_sid);
-  gcc_assert (expr_svalue);
-  if (const poisoned_svalue *poisoned_sval
-	= expr_svalue->dyn_cast_poisoned_svalue ())
-    {
-      enum poison_kind pkind = poisoned_sval->get_poison_kind ();
-      ctxt->warn (new poisoned_value_diagnostic (expr, pkind));
-    }
-}
-
-/* Update this model for the ASSIGN stmt, using CTXT to report any
-   diagnostics.  */
+/* If ASSIGN is a stmt that can be modelled via
+     set_value (lhs_reg, SVALUE, CTXT)
+   for some SVALUE, get the SVALUE.
+   Otherwise return NULL.  */
 
-void
-region_model::on_assignment (const gassign *assign, region_model_context *ctxt)
+const svalue *
+region_model::get_gassign_result (const gassign *assign,
+				   region_model_context *ctxt)
 {
   tree lhs = gimple_assign_lhs (assign);
   tree rhs1 = gimple_assign_rhs1 (assign);
-
-  region_id lhs_rid = get_lvalue (lhs, ctxt);
-
-  /* Check for uses of poisoned values.  */
-  switch (get_gimple_rhs_class (gimple_expr_code (assign)))
-    {
-    case GIMPLE_INVALID_RHS:
-      gcc_unreachable ();
-      break;
-    case GIMPLE_TERNARY_RHS:
-      check_for_poison (gimple_assign_rhs3 (assign), ctxt);
-      /* Fallthru */
-    case GIMPLE_BINARY_RHS:
-      check_for_poison (gimple_assign_rhs2 (assign), ctxt);
-      /* Fallthru */
-    case GIMPLE_UNARY_RHS:
-    case GIMPLE_SINGLE_RHS:
-      check_for_poison (gimple_assign_rhs1 (assign), ctxt);
-    }
-
-  if (lhs_rid.null_p ())
-    return;
-  // TODO: issue a warning for this case
-
   enum tree_code op = gimple_assign_rhs_code (assign);
   switch (op)
     {
     default:
-      {
-	if (0)
-	  sorry_at (assign->location, "unhandled assignment op: %qs",
-		    get_tree_code_name (op));
-	set_to_new_unknown_value (lhs_rid, TREE_TYPE (lhs), ctxt);
-      }
-      break;
-
-    case BIT_FIELD_REF:
-      {
-	// TODO
-      }
-      break;
-
-    case CONSTRUCTOR:
-      {
-	/* e.g. "x ={v} {CLOBBER};"  */
-	// TODO
-      }
-      break;
+      return NULL;
 
     case POINTER_PLUS_EXPR:
       {
@@ -4189,69 +391,71 @@ region_model::on_assignment (const gassign *assign, region_model_context *ctxt)
 	tree ptr = rhs1;
 	tree offset = gimple_assign_rhs2 (assign);
 
-	svalue_id ptr_sid = get_rvalue (ptr, ctxt);
-	svalue_id offset_sid = get_rvalue (offset, ctxt);
-	region_id element_rid
-	  = get_or_create_pointer_plus_expr (TREE_TYPE (TREE_TYPE (ptr)),
-					     ptr_sid, offset_sid,
-					     ctxt);
-	svalue_id element_ptr_sid
-	  = get_or_create_ptr_svalue (TREE_TYPE (ptr), element_rid);
-	set_value (lhs_rid, element_ptr_sid, ctxt);
+	const svalue *ptr_sval = get_rvalue (ptr, ctxt);
+	const svalue *offset_sval = get_rvalue (offset, ctxt);
+	/* Quoting tree.def, "the second operand [of a POINTER_PLUS_EXPR]
+	   is an integer of type sizetype".  */
+	offset_sval = m_mgr->get_or_create_cast (size_type_node, offset_sval);
+
+	const svalue *sval_binop
+	  = m_mgr->get_or_create_binop (TREE_TYPE (lhs), op,
+					ptr_sval, offset_sval);
+	return sval_binop;
       }
       break;
 
     case POINTER_DIFF_EXPR:
       {
 	/* e.g. "_1 = p_2(D) - q_3(D);".  */
+	tree rhs2 = gimple_assign_rhs2 (assign);
+	const svalue *rhs1_sval = get_rvalue (rhs1, ctxt);
+	const svalue *rhs2_sval = get_rvalue (rhs2, ctxt);
 
-	/* TODO.  */
-
-	set_to_new_unknown_value (lhs_rid, TREE_TYPE (lhs), ctxt);
-      }
-      break;
+	// TODO: perhaps fold to zero if they're known to be equal?
 
-    case ADDR_EXPR:
-      {
-	/* LHS = &RHS;  */
-	svalue_id ptr_sid = get_rvalue (rhs1, ctxt);
-	set_value (lhs_rid, ptr_sid, ctxt);
+	const svalue *sval_binop
+	  = m_mgr->get_or_create_binop (TREE_TYPE (lhs), op,
+					rhs1_sval, rhs2_sval);
+	return sval_binop;
       }
       break;
 
+    /* Assignments of the form
+	set_value (lvalue (LHS), rvalue (EXPR))
+       for various EXPR.
+       We already have the lvalue for the LHS above, as "lhs_reg".  */
+    case ADDR_EXPR: /* LHS = &RHS;  */
+    case BIT_FIELD_REF:
+    case COMPONENT_REF: /* LHS = op0.op1;  */
     case MEM_REF:
-      {
-	region_id rhs_rid = get_lvalue (rhs1, ctxt);
-	svalue_id rhs_sid
-	  = get_region (rhs_rid)->get_value (*this, true, ctxt);
-	set_value (lhs_rid, rhs_sid, ctxt);
-      }
-      break;
-
     case REAL_CST:
+    case COMPLEX_CST:
+    case VECTOR_CST:
     case INTEGER_CST:
     case ARRAY_REF:
-      {
-	/* LHS = RHS;  */
-	svalue_id cst_sid = get_rvalue (rhs1, ctxt);
-	set_value (lhs_rid, cst_sid, ctxt);
-      }
-      break;
-
+    case SSA_NAME: /* LHS = VAR; */
+    case VAR_DECL: /* LHS = VAR; */
+    case PARM_DECL:/* LHS = VAR; */
+    case REALPART_EXPR:
+    case IMAGPART_EXPR:
+      return get_rvalue (rhs1, ctxt);
+
+    case ABS_EXPR:
+    case ABSU_EXPR:
+    case CONJ_EXPR:
+    case BIT_NOT_EXPR:
     case FIX_TRUNC_EXPR:
     case FLOAT_EXPR:
+    case NEGATE_EXPR:
     case NOP_EXPR:
-      // cast: TODO
-      // fall though for now
-    case SSA_NAME:
-    case VAR_DECL:
-    case PARM_DECL:
+    case VIEW_CONVERT_EXPR:
       {
-	/* LHS = VAR;  */
-	region_id rhs_rid = get_lvalue (rhs1, ctxt);
-	copy_region (lhs_rid, rhs_rid, ctxt);
+	/* Unary ops.  */
+	const svalue *rhs_sval = get_rvalue (rhs1, ctxt);
+	const svalue *sval_unaryop
+	  = m_mgr->get_or_create_unaryop (TREE_TYPE (lhs), op, rhs_sval);
+	return sval_unaryop;
       }
-      break;
 
     case EQ_EXPR:
     case GE_EXPR:
@@ -4259,80 +463,155 @@ region_model::on_assignment (const gassign *assign, region_model_context *ctxt)
     case NE_EXPR:
     case GT_EXPR:
     case LT_EXPR:
+    case UNORDERED_EXPR:
+    case ORDERED_EXPR:
       {
 	tree rhs2 = gimple_assign_rhs2 (assign);
 
 	// TODO: constraints between svalues
-	svalue_id rhs1_sid = get_rvalue (rhs1, ctxt);
-	svalue_id rhs2_sid = get_rvalue (rhs2, ctxt);
+	const svalue *rhs1_sval = get_rvalue (rhs1, ctxt);
+	const svalue *rhs2_sval = get_rvalue (rhs2, ctxt);
 
-	tristate t = eval_condition (rhs1_sid, op, rhs2_sid);
+	tristate t = eval_condition (rhs1_sval, op, rhs2_sval);
 	if (t.is_known ())
-	  set_value (lhs_rid,
-		     get_rvalue (t.is_true ()
-				 ? boolean_true_node
-				 : boolean_false_node,
-				 ctxt),
-		     ctxt);
+	  return get_rvalue (t.is_true ()
+			     ? boolean_true_node
+			     : boolean_false_node,
+			     ctxt);
 	else
-	  set_to_new_unknown_value (lhs_rid, TREE_TYPE (lhs), ctxt);
-      }
-      break;
-
-    case NEGATE_EXPR:
-    case BIT_NOT_EXPR:
-      {
-	// TODO: unary ops
-
-	// TODO: constant?
-
-	set_to_new_unknown_value (lhs_rid, TREE_TYPE (lhs), ctxt);
+	  {
+	    // TODO: symbolic value for binop
+	    const svalue *sval_binop
+	      = m_mgr->get_or_create_binop (TREE_TYPE (lhs), op,
+					    rhs1_sval, rhs2_sval);
+	    return sval_binop;
+	  }
       }
       break;
 
     case PLUS_EXPR:
     case MINUS_EXPR:
     case MULT_EXPR:
+    case MULT_HIGHPART_EXPR:
     case TRUNC_DIV_EXPR:
+    case CEIL_DIV_EXPR:
+    case FLOOR_DIV_EXPR:
+    case ROUND_DIV_EXPR:
     case TRUNC_MOD_EXPR:
+    case CEIL_MOD_EXPR:
+    case FLOOR_MOD_EXPR:
+    case ROUND_MOD_EXPR:
+    case RDIV_EXPR:
+    case EXACT_DIV_EXPR:
     case LSHIFT_EXPR:
     case RSHIFT_EXPR:
+    case LROTATE_EXPR:
+    case RROTATE_EXPR:
     case BIT_IOR_EXPR:
     case BIT_XOR_EXPR:
     case BIT_AND_EXPR:
     case MIN_EXPR:
     case MAX_EXPR:
+    case COMPLEX_EXPR:
       {
 	/* Binary ops.  */
 	tree rhs2 = gimple_assign_rhs2 (assign);
 
-	svalue_id rhs1_sid = get_rvalue (rhs1, ctxt);
-	svalue_id rhs2_sid = get_rvalue (rhs2, ctxt);
+	const svalue *rhs1_sval = get_rvalue (rhs1, ctxt);
+	const svalue *rhs2_sval = get_rvalue (rhs2, ctxt);
 
-	if (tree rhs1_cst = maybe_get_constant (rhs1_sid))
-	  if (tree rhs2_cst = maybe_get_constant (rhs2_sid))
-	    {
-	      tree result = fold_binary (op, TREE_TYPE (lhs),
-					 rhs1_cst, rhs2_cst);
-	      if (result && CONSTANT_CLASS_P (result))
-		{
-		  svalue_id result_sid
-		    = get_or_create_constant_svalue (result);
-		  set_value (lhs_rid, result_sid, ctxt);
-		  return;
-		}
-	    }
-	set_to_new_unknown_value (lhs_rid, TREE_TYPE (lhs), ctxt);
+	const svalue *sval_binop
+	  = m_mgr->get_or_create_binop (TREE_TYPE (lhs), op,
+					rhs1_sval, rhs2_sval);
+	return sval_binop;
+      }
+
+    /* Vector expressions.  In theory we could implement these elementwise,
+       but for now, simply return unknown values.  */
+    case VEC_DUPLICATE_EXPR:
+    case VEC_SERIES_EXPR:
+    case VEC_COND_EXPR:
+    case VEC_PERM_EXPR:
+      return m_mgr->get_or_create_unknown_svalue (TREE_TYPE (lhs));
+    }
+}
+
+/* Update this model for the ASSIGN stmt, using CTXT to report any
+   diagnostics.  */
+
+void
+region_model::on_assignment (const gassign *assign, region_model_context *ctxt)
+{
+  tree lhs = gimple_assign_lhs (assign);
+  tree rhs1 = gimple_assign_rhs1 (assign);
+
+  const region *lhs_reg = get_lvalue (lhs, ctxt);
+
+  /* Most assignments are handled by:
+       set_value (lhs_reg, SVALUE, CTXT)
+     for some SVALUE.  */
+  if (const svalue *sval = get_gassign_result (assign, ctxt))
+    {
+      set_value (lhs_reg, sval, ctxt);
+      return;
+    }
+
+  enum tree_code op = gimple_assign_rhs_code (assign);
+  switch (op)
+    {
+    default:
+      {
+	if (1)
+	  sorry_at (assign->location, "unhandled assignment op: %qs",
+		    get_tree_code_name (op));
+	gcc_unreachable ();
       }
       break;
 
-    case COMPONENT_REF:
+    case CONSTRUCTOR:
+      {
+	if (TREE_CLOBBER_P (rhs1))
+	  {
+	    /* e.g. "x ={v} {CLOBBER};"  */
+	    clobber_region (lhs_reg);
+	  }
+	else
+	  {
+	    /* Any CONSTRUCTOR that survives to this point is either
+	       just a zero-init of everything, or a vector.  */
+	    if (!CONSTRUCTOR_NO_CLEARING (rhs1))
+	      zero_fill_region (lhs_reg);
+	    unsigned ix;
+	    tree index;
+	    tree val;
+	    FOR_EACH_CONSTRUCTOR_ELT (CONSTRUCTOR_ELTS (rhs1), ix, index, val)
+	      {
+		gcc_assert (TREE_CODE (TREE_TYPE (rhs1)) == VECTOR_TYPE);
+		if (!index)
+		  index = build_int_cst (integer_type_node, ix);
+		gcc_assert (TREE_CODE (index) == INTEGER_CST);
+		const svalue *index_sval
+		  = m_mgr->get_or_create_constant_svalue (index);
+		gcc_assert (index_sval);
+		const region *sub_reg
+		  = m_mgr->get_element_region (lhs_reg,
+					       TREE_TYPE (val),
+					       index_sval);
+		const svalue *val_sval = get_rvalue (val, ctxt);
+		set_value (sub_reg, val_sval, ctxt);
+	      }
+	  }
+      }
+      break;
+
+    case STRING_CST:
       {
-	/* LHS = op0.op1;  */
-	region_id child_rid = get_lvalue (rhs1, ctxt);
-	svalue_id child_sid
-	  = get_region (child_rid)->get_value (*this, true, ctxt);
-	set_value (lhs_rid, child_sid, ctxt);
+	/* e.g. "struct s2 x = {{'A', 'B', 'C', 'D'}};".  */
+	/* Add a default binding, rather than a direct one, so that array
+	   access will "inherit" the individual chars.  */
+	const svalue *rhs_sval = get_rvalue (rhs1, ctxt);
+	m_store.set_value (m_mgr->get_store_manager(), lhs_reg, rhs_sval,
+			   BK_default);
       }
       break;
     }
